#!/bin/sh
# Enable pcscd auto start on Mac OS X 10.8+ and 10.9+
# Developed under GPL

if [[ $(id -u) -ne 0 ]]; then
	echo "Please run the script as root\n"
	exit
fi

if [ ! -e /usr/sbin/pcscd ]; then
	echo "PCSCD not found!\n please check if PCSCD is installed."
	exit
fi

UNINSTALL=false
if [[ $1 == '-u' ]]; then
	UNINSTALL=true
	echo "$UNINSTALL"
fi
OSVER=`sw_vers -productVersion`
BASEPATH="/Library/LaunchDaemons"
DEFPLIST="org.opensc.pcscd.autostart"

if [[ $OSVER =~ ^(10)(\.[8,9])(.*)$ ]]; then
	echo "initialize pcscd auto start \n"
	if "$UNINSTALL" ; then
		if [ ! -e $BASEPATH/$DEFPLIST.plist ]; then
			echo "unable to locate PCSCD plist\n exit.\n"
			exit
		fi
		echo "remove pcscd from autostart daemons \n"
		`launchctl unload $BASEPATH/$DEFPLIST.plist`
		echo ".\c"
		`rm $BASEPATH/$DEFPLIST.plist`
	else
		if [ -e $BASEPATH/$DEFPLIST ]; then
			echo "enable default plist\n"
			`cp $BASEPATH/$DEFPLIST $BASEPATH/$DEFPLIST.plist` 
		else
			echo "default plist not found, create service\n"
			`uudecode $0`
			`cp org.opensc.pcscd.plist $BASEPATH/$DEFPLIST.plist`
		fi
		echo ".\c"
		`launchctl load $BASEPATH/$DEFPLIST.plist`
		echo ".\c"
	fi
	echo ".\n Done!"
else
	echo "OS X $OSVER is not supported by this script!\n"
fi

exit 0
begin 644 org.opensc.pcscd.plist
M/#]X;6P@=F5R<VEO;CTB,2XP(B!E;F-O9&EN9STB551&+3@B/SX*/"%$3T-4
M65!%('!L:7-T(%!50DQ)0R`B+2\O07!P;&4O+T141"!03$E35"`Q+C`O+T5.
M(B`B:'1T<#HO+W=W=RYA<'!L92YC;VTO1%1$<R]0<F]P97)T>4QI<W0M,2XP
M+F1T9"(^"CQP;&ES="!V97)S:6]N/2(Q+C`B/@H)/&1I8W0^"B`@("`\:V5Y
M/D=)1#PO:V5Y/@H@("`@/&EN=&5G97(^,#PO:6YT96=E<CX*("`@(#QK97D^
M3&%B96P\+VME>3X*("`@(#QS=')I;F<^;W)G+F]P96YS8RYP8W-C9"YA=71O
M<W1A<G0\+W-T<FEN9SX*("`@(#QK97D^3VY$96UA;F0\+VME>3X*("`@(#QF
M86QS92\^"B`@("`\:V5Y/E!R;V=R86U!<F=U;65N=',\+VME>3X*("`@(#QA
M<G)A>3X*("`@("`@/'-T<FEN9SXO=7-R+W-B:6XO<&-S8V0\+W-T<FEN9SX*
M("`@("`@/'-T<FEN9SXM9CPO<W1R:6YG/@H@("`@/"]A<G)A>3X*("`@(#QK
M97D^4G5N071,;V%D/"]K97D^"B`@("`\=')U92\^"B`@("`\:V5Y/E5S97).
M86UE/"]K97D^"B`@("`\<W1R:6YG/G)O;W0\+W-T<FEN9SX*"3PO9&EC=#X*
)/"]P;&ES=#X*
`
end
